diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/frame-exchange-manager.h ns-3.44/src/wifi/model/frame-exchange-manager.h
--- ns-3.43/src/wifi/model/frame-exchange-manager.h	2024-10-09 16:41:10.120656700 -0700
+++ ns-3.44/src/wifi/model/frame-exchange-manager.h	2025-03-09 16:55:49.787372600 -0700
@@ -35,12 +35,15 @@
 namespace ns3
 {
 
+class ApWifiMac;
+class StaWifiMac;
+
 struct RxSignalInfo;
 struct WifiProtection;
 struct WifiAcknowledgment;
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  *
  * FrameExchangeManager is a base class handling the basic frame exchange
  * sequences for non-QoS stations.
@@ -57,8 +60,8 @@
 {
   public:
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
     FrameExchangeManager();
@@ -76,10 +79,10 @@
     /**
      * Request the FrameExchangeManager to start a frame exchange sequence.
      *
-     * \param dcf the channel access function that gained channel access. It is
+     * @param dcf the channel access function that gained channel access. It is
      *            the DCF on non-QoS stations and an EDCA on QoS stations.
-     * \param allowedWidth the allowed width for the frame exchange sequence
-     * \return true if a frame exchange sequence was started, false otherwise
+     * @param allowedWidth the allowed width for the frame exchange sequence
+     * @return true if a frame exchange sequence was started, false otherwise
      */
     virtual bool StartTransmission(Ptr<Txop> dcf, MHz_u allowedWidth);
 
@@ -89,15 +92,15 @@
      * the PSDU contains multiple MPDUs, the <i>perMpduStatus</i> vector is empty
      * when receiving the individual MPDUs.
      *
-     * \param psdu the received PSDU
-     * \param rxSignalInfo the info on the received signal (\see RxSignalInfo)
-     * \param txVector TxVector of the received PSDU
-     * \param perMpduStatus per MPDU reception status
+     * @param psdu the received PSDU
+     * @param rxSignalInfo the info on the received signal (\see RxSignalInfo)
+     * @param txVector TxVector of the received PSDU
+     * @param perMpduStatus per MPDU reception status
      */
     void Receive(Ptr<const WifiPsdu> psdu,
                  RxSignalInfo rxSignalInfo,
-                 WifiTxVector txVector,
-                 std::vector<bool> perMpduStatus);
+                 const WifiTxVector& txVector,
+                 const std::vector<bool>& perMpduStatus);
 
     /**
      * Information about the MPDU being received. The TXVECTOR is populated upon
@@ -111,14 +114,14 @@
     };
 
     /**
-     * \return the information about the MPDU being received by the PHY, if any. This information
+     * @return the information about the MPDU being received by the PHY, if any. This information
      *         is available from the time the PHY-RXSTART.indication is received until the end
      *         of PSDU reception
      */
     std::optional<std::reference_wrapper<const OngoingRxInfo>> GetOngoingRxInfo() const;
 
     /**
-     * \return the information about the MAC header of the MPDU being received by the PHY, if any.
+     * @return the information about the MAC header of the MPDU being received by the PHY, if any.
      *         The MAC header is available from the time its reception is completed until the end
      *         of PSDU reception
      */
@@ -127,37 +130,37 @@
     /**
      * Set the ID of the link this Frame Exchange Manager is associated with.
      *
-     * \param linkId the ID of the link this Frame Exchange Manager is associated with
+     * @param linkId the ID of the link this Frame Exchange Manager is associated with
      */
     virtual void SetLinkId(uint8_t linkId);
     /**
      * Set the MAC layer to use.
      *
-     * \param mac the MAC layer to use
+     * @param mac the MAC layer to use
      */
     virtual void SetWifiMac(const Ptr<WifiMac> mac);
     /**
      * Set the MAC TX Middle to use.
      *
-     * \param txMiddle the MAC TX Middle to use
+     * @param txMiddle the MAC TX Middle to use
      */
     virtual void SetMacTxMiddle(const Ptr<MacTxMiddle> txMiddle);
     /**
      * Set the MAC RX Middle to use.
      *
-     * \param rxMiddle the MAC RX Middle to use
+     * @param rxMiddle the MAC RX Middle to use
      */
     virtual void SetMacRxMiddle(const Ptr<MacRxMiddle> rxMiddle);
     /**
      * Set the channel access manager to use
      *
-     * \param channelAccessManager the channel access manager to use
+     * @param channelAccessManager the channel access manager to use
      */
     virtual void SetChannelAccessManager(const Ptr<ChannelAccessManager> channelAccessManager);
     /**
      * Set the PHY layer to use.
      *
-     * \param phy the PHY layer to use
+     * @param phy the PHY layer to use
      */
     virtual void SetWifiPhy(const Ptr<WifiPhy> phy);
     /**
@@ -167,53 +170,53 @@
     /**
      * Set the Protection Manager to use
      *
-     * \param protectionManager the Protection Manager to use
+     * @param protectionManager the Protection Manager to use
      */
     virtual void SetProtectionManager(Ptr<WifiProtectionManager> protectionManager);
     /**
      * Set the Acknowledgment Manager to use
      *
-     * \param ackManager the Acknowledgment Manager to use
+     * @param ackManager the Acknowledgment Manager to use
      */
     virtual void SetAckManager(Ptr<WifiAckManager> ackManager);
     /**
      * Set the MAC address.
      *
-     * \param address the MAC address
+     * @param address the MAC address
      */
     virtual void SetAddress(Mac48Address address);
     /**
      * Get the MAC address.
      *
-     * \return the MAC address
+     * @return the MAC address
      */
     Mac48Address GetAddress() const;
     /**
      * Set the Basic Service Set Identification.
      *
-     * \param bssid the BSSID
+     * @param bssid the BSSID
      */
     virtual void SetBssid(Mac48Address bssid);
     /**
      * Get the Basic Service Set Identification.
      *
-     * \return the BSSID
+     * @return the BSSID
      */
     Mac48Address GetBssid() const;
     /**
-     * \return the width of the channel that the FEM is allowed to use for the current transmission
+     * @return the width of the channel that the FEM is allowed to use for the current transmission
      */
     MHz_u GetAllowedWidth() const;
     /**
      * Set the callback to invoke when an MPDU is dropped.
      *
-     * \param callback the callback to invoke when an MPDU is dropped
+     * @param callback the callback to invoke when an MPDU is dropped
      */
     virtual void SetDroppedMpduCallback(DroppedMpdu callback);
     /**
      * Set the callback to invoke when an MPDU is successfully acked.
      *
-     * \param callback the callback to invoke when an MPDU is successfully acked
+     * @param callback the callback to invoke when an MPDU is successfully acked
      */
     void SetAckedMpduCallback(AckedMpdu callback);
     /**
@@ -223,7 +226,7 @@
     /**
      * Check if the device is operating in promiscuous mode.
      *
-     * \return true if the device is operating in promiscuous mode,
+     * @return true if the device is operating in promiscuous mode,
      *         false otherwise
      */
     bool IsPromisc() const;
@@ -231,14 +234,14 @@
     /**
      * Get a const reference to the WifiTxTimer object.
      *
-     * \return a const reference to the WifiTxTimer object
+     * @return a const reference to the WifiTxTimer object
      */
     const WifiTxTimer& GetWifiTxTimer() const;
 
     /**
      * Get the Protection Manager used by this node.
      *
-     * \return the Protection Manager used by this node
+     * @return the Protection Manager used by this node
      */
     Ptr<WifiProtectionManager> GetProtectionManager() const;
 
@@ -247,14 +250,14 @@
      * protection method. The protection time is stored in the protection
      * object itself.
      *
-     * \param protection the protection method
+     * @param protection the protection method
      */
     virtual void CalculateProtectionTime(WifiProtection* protection) const;
 
     /**
      * Get the Acknowledgment Manager used by this node.
      *
-     * \return the Acknowledgment Manager used by this node
+     * @return the Acknowledgment Manager used by this node
      */
     Ptr<WifiAckManager> GetAckManager() const;
 
@@ -263,29 +266,29 @@
      * acknowledgment method. The acknowledgment time is stored in the acknowledgment
      * object itself.
      *
-     * \param acknowledgment the acknowledgment method
+     * @param acknowledgment the acknowledgment method
      */
     virtual void CalculateAcknowledgmentTime(WifiAcknowledgment* acknowledgment) const;
 
     /**
-     * \return true if the virtual CS indication is that the medium is idle
+     * @return true if the virtual CS indication is that the medium is idle
      */
     virtual bool VirtualCsMediumIdle() const;
 
     /**
-     * \return the set of stations that have successfully received an RTS in this TXOP.
+     * @return the set of stations that have successfully received an RTS in this TXOP.
      */
     const std::set<Mac48Address>& GetProtectedStas() const;
 
     /**
      * Notify that an internal collision has occurred for the given Txop
      *
-     * \param txop the Txop for which an internal collision has occurred
+     * @param txop the Txop for which an internal collision has occurred
      */
     virtual void NotifyInternalCollision(Ptr<Txop> txop);
 
     /**
-     * \param duration switching delay duration.
+     * @param duration switching delay duration.
      *
      * This method is typically invoked by the PhyListener to notify
      * the MAC layer that a channel switching occurred. When a channel switching
@@ -311,7 +314,7 @@
     void DoDispose() override;
 
     /**
-     * \return the remote station manager operating on our link
+     * @return the remote station manager operating on our link
      */
     Ptr<WifiRemoteStationManager> GetWifiRemoteStationManager() const;
 
@@ -321,8 +324,8 @@
      * is applied, the given MPDU is dequeued from the MAC queue and the first
      * fragment is enqueued in its place.
      *
-     * \param mpdu the given MPDU
-     * \return the first fragment if fragmentation is needed, the given MPDU otherwise
+     * @param mpdu the given MPDU
+     * @return the first fragment if fragmentation is needed, the given MPDU otherwise
      */
     Ptr<WifiMpdu> GetFirstFragmentIfNeeded(Ptr<WifiMpdu> mpdu);
 
@@ -331,28 +334,29 @@
      * Note that <i>txParams</i> is moved to m_txParams and hence is left in an
      * undefined state.
      *
-     * \param mpdu the MPDU to send
-     * \param txParams the TX parameters to use to transmit the MPDU
+     * @param mpdu the MPDU to send
+     * @param txParams the TX parameters to use to transmit the MPDU
      */
     void SendMpduWithProtection(Ptr<WifiMpdu> mpdu, WifiTxParameters& txParams);
 
     /**
      * Start the protection mechanism indicated by the given TX parameters
      *
-     * \param txParams the TX parameters
+     * @param txParams the TX parameters
      */
     virtual void StartProtection(const WifiTxParameters& txParams);
 
     /**
-     * Transmit prepared frame upon successful protection mechanism.
+     * Transmit prepared frame immediately, if no protection was used, or in a SIFS, if protection
+     * was completed successfully.
      */
     virtual void ProtectionCompleted();
 
     /**
      * Update the NAV, if needed, based on the Duration/ID of the given <i>psdu</i>.
      *
-     * \param psdu the received PSDU
-     * \param txVector TxVector of the received PSDU
+     * @param psdu the received PSDU
+     * @param txVector TxVector of the received PSDU
      */
     virtual void UpdateNav(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector);
 
@@ -364,17 +368,17 @@
     /**
      * This method is called when the reception of a PSDU fails.
      *
-     * \param psdu the PSDU whose reception failed
+     * @param psdu the PSDU whose reception failed
      */
     virtual void PsduRxError(Ptr<const WifiPsdu> psdu);
 
     /**
      * This method handles the reception of an MPDU (possibly included in an A-MPDU)
      *
-     * \param mpdu the received MPDU
-     * \param rxSignalInfo the info on the received signal (\see RxSignalInfo)
-     * \param txVector TxVector of the received PSDU
-     * \param inAmpdu true if the MPDU is part of an A-MPDU
+     * @param mpdu the received MPDU
+     * @param rxSignalInfo the info on the received signal (\see RxSignalInfo)
+     * @param txVector TxVector of the received PSDU
+     * @param inAmpdu true if the MPDU is part of an A-MPDU
      */
     virtual void ReceiveMpdu(Ptr<const WifiMpdu> mpdu,
                              RxSignalInfo rxSignalInfo,
@@ -385,10 +389,10 @@
      * This method is called when the reception of an A-MPDU including multiple
      * MPDUs is completed.
      *
-     * \param psdu the received PSDU
-     * \param rxSignalInfo the info on the received signal (\see RxSignalInfo)
-     * \param txVector TxVector of the received PSDU
-     * \param perMpduStatus per MPDU reception status
+     * @param psdu the received PSDU
+     * @param rxSignalInfo the info on the received signal (\see RxSignalInfo)
+     * @param txVector TxVector of the received PSDU
+     * @param perMpduStatus per MPDU reception status
      */
     virtual void EndReceiveAmpdu(Ptr<const WifiPsdu> psdu,
                                  const RxSignalInfo& rxSignalInfo,
@@ -398,11 +402,11 @@
     /**
      * Perform the actions needed when a Normal Ack is received.
      *
-     * \param mpdu the MPDU that was acknowledged
-     * \param txVector the TXVECTOR used to transmit the MPDU that was acknowledged
-     * \param ackTxVector the TXVECTOR used to transmit the Normal Ack frame
-     * \param rxInfo the info on the received signal (\see RxSignalInfo)
-     * \param snr the SNR at the receiver for the MPDU that was acknowledged
+     * @param mpdu the MPDU that was acknowledged
+     * @param txVector the TXVECTOR used to transmit the MPDU that was acknowledged
+     * @param ackTxVector the TXVECTOR used to transmit the Normal Ack frame
+     * @param rxInfo the info on the received signal (\see RxSignalInfo)
+     * @param snr the SNR at the receiver for the MPDU that was acknowledged
      */
     virtual void ReceivedNormalAck(Ptr<WifiMpdu> mpdu,
                                    const WifiTxVector& txVector,
@@ -413,14 +417,14 @@
     /**
      * Notify other components that an MPDU was acknowledged.
      *
-     * \param mpdu the MPDU that was acknowledged
+     * @param mpdu the MPDU that was acknowledged
      */
     virtual void NotifyReceivedNormalAck(Ptr<WifiMpdu> mpdu);
 
     /**
      * Retransmit an MPDU that was not acknowledged.
      *
-     * \param mpdu the MPDU to retransmit
+     * @param mpdu the MPDU to retransmit
      */
     virtual void RetransmitMpduAfterMissedAck(Ptr<WifiMpdu> mpdu) const;
 
@@ -428,7 +432,7 @@
      * Make the sequence numbers of MPDUs included in the given PSDU available again
      * if the MPDUs have never been transmitted.
      *
-     * \param psdu the given PSDU
+     * @param psdu the given PSDU
      */
     virtual void ReleaseSequenceNumbers(Ptr<const WifiPsdu> psdu) const;
 
@@ -436,7 +440,7 @@
      * Pass the given MPDU, discarded because of the max retry limit was reached,
      * to the MPDU dropped callback.
      *
-     * \param mpdu the discarded MPDU
+     * @param mpdu the discarded MPDU
      */
     virtual void NotifyPacketDiscarded(Ptr<const WifiMpdu> mpdu);
 
@@ -445,8 +449,8 @@
      * independently of whether the frame is addressed to this station
      * (e.g., storing buffer status reports).
      *
-     * \param psdu the received PSDU
-     * \param txVector TX vector of the received PSDU
+     * @param psdu the received PSDU
+     * @param txVector TX vector of the received PSDU
      */
     virtual void PreProcessFrame(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector);
 
@@ -455,8 +459,8 @@
      * independently of whether the frame is addressed to this station
      * (e.g., setting the NAV or the TXOP holder).
      *
-     * \param psdu the received PSDU
-     * \param txVector TX vector of the received PSDU
+     * @param psdu the received PSDU
+     * @param txVector TX vector of the received PSDU
      */
     virtual void PostProcessFrame(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector);
 
@@ -465,10 +469,10 @@
      * parameters if the size of the PSDU addressed to the given receiver
      * becomes <i>ppduPayloadSize</i>.
      *
-     * \param ppduPayloadSize the new PSDU size
-     * \param receiver the MAC address of the receiver of the PSDU
-     * \param txParams the TX parameters
-     * \return the updated TX duration
+     * @param ppduPayloadSize the new PSDU size
+     * @param receiver the MAC address of the receiver of the PSDU
+     * @param txParams the TX parameters
+     * @return the updated TX duration
      */
     virtual Time GetTxDuration(uint32_t ppduPayloadSize,
                                Mac48Address receiver,
@@ -478,8 +482,8 @@
      * Update the TX duration field of the given TX parameters after that the PSDU
      * addressed to the given receiver has changed.
      *
-     * \param receiver the MAC address of the receiver of the PSDU
-     * \param txParams the TX parameters
+     * @param receiver the MAC address of the receiver of the PSDU
+     * @param txParams the TX parameters
      */
     void UpdateTxDuration(Mac48Address receiver, WifiTxParameters& txParams) const;
 
@@ -488,23 +492,26 @@
      * given TXVECTOR. The purpose of this method is that it can be overridden to
      * compute the size of an S-MPDU.
      *
-     * \param mpdu the given MPDU
-     * \param txVector the given TXVECTOR
-     * \return the size of the MPDU
+     * @param mpdu the given MPDU
+     * @param txVector the given TXVECTOR
+     * @return the size of the MPDU
      */
     virtual uint32_t GetPsduSize(Ptr<const WifiMpdu> mpdu, const WifiTxVector& txVector) const;
 
     /**
      * Notify the given Txop that channel has been released.
      *
-     * \param txop the given Txop
+     * @param txop the given Txop
      */
     virtual void NotifyChannelReleased(Ptr<Txop> txop);
 
     Ptr<Txop> m_dcf;                                  //!< the DCF/EDCAF that gained channel access
     WifiTxTimer m_txTimer;                            //!< the timer set upon frame transmission
     EventId m_navResetEvent;                          //!< the event to reset the NAV after an RTS
+    EventId m_sendCtsEvent;                           //!< the event to send a CTS after an (MU-)RTS
     Ptr<WifiMac> m_mac;                               //!< the MAC layer on this station
+    Ptr<ApWifiMac> m_apMac;                           //!< AP MAC layer pointer (null if not an AP)
+    Ptr<StaWifiMac> m_staMac;                         //!< STA MAC layer pointer (null if not a STA)
     Ptr<MacTxMiddle> m_txMiddle;                      //!< the MAC TX Middle on this station
     Ptr<MacRxMiddle> m_rxMiddle;                      //!< the MAC RX Middle on this station
     Ptr<ChannelAccessManager> m_channelAccessManager; //!< the channel access manager
@@ -512,34 +519,39 @@
     Mac48Address m_self;                              //!< the MAC address of this device
     Mac48Address m_bssid;                             //!< BSSID address (Mac48Address)
     Time m_navEnd;                                    //!< NAV expiration time
+    Time m_txNav;                                     //!< the TXNAV timer
     std::set<Mac48Address> m_sentRtsTo; //!< the STA(s) which we sent an RTS to (waiting for CTS)
+    std::set<Mac48Address>
+        m_sentFrameTo; //!< the STA(s) to which we sent a frame requesting a response
     std::set<Mac48Address> m_protectedStas; //!< STAs that have replied to an RTS in this TXOP
-    uint8_t m_linkId;                       //!< the ID of the link this object is associated with
-    MHz_u m_allowedWidth;                   //!< the allowed width for the current transmission
-    bool m_promisc;                         //!< Flag if the device is operating in promiscuous mode
-    DroppedMpdu m_droppedMpduCallback;      //!< the dropped MPDU callback
-    AckedMpdu m_ackedMpduCallback;          //!< the acknowledged MPDU callback
+    bool m_protectedIfResponded;       //!< whether a STA is assumed to be protected if replied to a
+                                       //!< frame requiring acknowledgment
+    uint8_t m_linkId;                  //!< the ID of the link this object is associated with
+    MHz_u m_allowedWidth;              //!< the allowed width for the current transmission
+    bool m_promisc;                    //!< Flag if the device is operating in promiscuous mode
+    DroppedMpdu m_droppedMpduCallback; //!< the dropped MPDU callback
+    AckedMpdu m_ackedMpduCallback;     //!< the acknowledged MPDU callback
 
     /**
      * Finalize the MAC header of the MPDUs in the given PSDU before transmission. Tasks
      * performed by this method include setting the Power Management flag in the MAC header.
      *
-     * \param psdu the given PSDU
+     * @param psdu the given PSDU
      */
     virtual void FinalizeMacHeader(Ptr<const WifiPsdu> psdu);
 
     /**
      * Forward an MPDU down to the PHY layer.
      *
-     * \param mpdu the MPDU to forward down
-     * \param txVector the TXVECTOR used to transmit the MPDU
+     * @param mpdu the MPDU to forward down
+     * @param txVector the TXVECTOR used to transmit the MPDU
      */
     virtual void ForwardMpduDown(Ptr<WifiMpdu> mpdu, WifiTxVector& txVector);
 
     /**
      * Dequeue the given MPDU from the queue in which it is stored.
      *
-     * \param mpdu the given MPDU
+     * @param mpdu the given MPDU
      */
     virtual void DequeueMpdu(Ptr<const WifiMpdu> mpdu);
 
@@ -547,12 +559,12 @@
      * Compute how to set the Duration/ID field of a frame being transmitted with
      * the given TX parameters
      *
-     * \param header the MAC header of the frame
-     * \param size the size of the frame in bytes
-     * \param txParams the TX parameters used to send the frame
-     * \param fragmentedPacket the packet that originated the frame to transmit, in case
+     * @param header the MAC header of the frame
+     * @param size the size of the frame in bytes
+     * @param txParams the TX parameters used to send the frame
+     * @param fragmentedPacket the packet that originated the frame to transmit, in case
      *                         the latter is a fragment
-     * \return the computed Duration/ID value
+     * @return the computed Duration/ID value
      */
     virtual Time GetFrameDurationId(const WifiMacHeader& header,
                                     uint32_t size,
@@ -563,10 +575,10 @@
      * Compute how to set the Duration/ID field of an RTS frame to send to protect
      * a frame transmitted with the given TX vector.
      *
-     * \param rtsTxVector the TX vector used to send the RTS frame
-     * \param txDuration the TX duration of the data frame
-     * \param response the time taken by the response (acknowledgment) to the data frame
-     * \return the computed Duration/ID value for the RTS frame
+     * @param rtsTxVector the TX vector used to send the RTS frame
+     * @param txDuration the TX duration of the data frame
+     * @param response the time taken by the response (acknowledgment) to the data frame
+     * @return the computed Duration/ID value for the RTS frame
      */
     virtual Time GetRtsDurationId(const WifiTxVector& rtsTxVector,
                                   Time txDuration,
@@ -575,25 +587,25 @@
     /**
      * Send RTS to begin RTS-CTS-Data-Ack transaction.
      *
-     * \param txParams the TX parameters for the data frame
+     * @param txParams the TX parameters for the data frame
      */
     void SendRts(const WifiTxParameters& txParams);
 
     /**
      * Send CTS after receiving RTS.
      *
-     * \param rtsHdr the header of the received RTS
-     * \param rtsTxMode the TX mode used to transmit the RTS
-     * \param rtsSnr the SNR of the RTS in linear scale
+     * @param rtsHdr the header of the received RTS
+     * @param rtsTxMode the TX mode used to transmit the RTS
+     * @param rtsSnr the SNR of the RTS in linear scale
      */
     virtual void SendCtsAfterRts(const WifiMacHeader& rtsHdr, WifiMode rtsTxMode, double rtsSnr);
 
     /**
      * Send CTS after receiving RTS.
      *
-     * \param rtsHdr the header of the received RTS
-     * \param ctsTxVector the TXVECTOR to use to transmit the CTS
-     * \param rtsSnr the SNR of the RTS in linear scale
+     * @param rtsHdr the header of the received RTS
+     * @param ctsTxVector the TXVECTOR to use to transmit the CTS
+     * @param rtsSnr the SNR of the RTS in linear scale
      */
     void DoSendCtsAfterRts(const WifiMacHeader& rtsHdr, WifiTxVector& ctsTxVector, double rtsSnr);
 
@@ -601,10 +613,10 @@
      * Compute how to set the Duration/ID field of a CTS-to-self frame to send to
      * protect a frame transmitted with the given TX vector.
      *
-     * \param ctsTxVector the TX vector used to send the CTS-to-self frame
-     * \param txDuration the TX duration of the data frame
-     * \param response the time taken by the response (acknowledgment) to the data frame
-     * \return the computed Duration/ID value for the CTS-to-self frame
+     * @param ctsTxVector the TX vector used to send the CTS-to-self frame
+     * @param txDuration the TX duration of the data frame
+     * @param response the time taken by the response (acknowledgment) to the data frame
+     * @return the computed Duration/ID value for the CTS-to-self frame
      */
     virtual Time GetCtsToSelfDurationId(const WifiTxVector& ctsTxVector,
                                         Time txDuration,
@@ -613,16 +625,16 @@
     /**
      * Send CTS for a CTS-to-self mechanism.
      *
-     * \param txParams the TX parameters for the data frame
+     * @param txParams the TX parameters for the data frame
      */
     void SendCtsToSelf(const WifiTxParameters& txParams);
 
     /**
      * Send Normal Ack.
      *
-     * \param hdr the header of the frame soliciting the Normal Ack
-     * \param dataTxVector the TXVECTOR used to transmit the frame soliciting the Normal Ack
-     * \param dataSnr the SNR of the frame soliciting the Normal Ack in linear scale
+     * @param hdr the header of the frame soliciting the Normal Ack
+     * @param dataTxVector the TXVECTOR used to transmit the frame soliciting the Normal Ack
+     * @param dataSnr the SNR of the frame soliciting the Normal Ack in linear scale
      */
     void SendNormalAck(const WifiMacHeader& hdr, const WifiTxVector& dataTxVector, double dataSnr);
 
@@ -630,7 +642,7 @@
      * Get the next fragment of the current MSDU.
      * Only called for fragmented MSDUs.
      *
-     * \return the next fragment of the current MSDU.
+     * @return the next fragment of the current MSDU.
      */
     Ptr<WifiMpdu> GetNextFragment();
 
@@ -643,40 +655,59 @@
     /**
      * Take necessary actions upon a transmission failure. A non-QoS station
      * releases the channel when this method is called.
+     *
+     * @param forceCurrentCw whether to force the contention window to stay equal to the current
+     *                       value (normally, contention window is updated upon TX failure)
      */
-    virtual void TransmissionFailed();
+    virtual void TransmissionFailed(bool forceCurrentCw = false);
+
+    /**
+     * Wrapper for the GetMpdusToDropOnTxFailure function of the remote station manager that
+     * additionally drops the MPDUs in the given PSDU that the remote station manager requested
+     * to drop.
+     *
+     * @param psdu the given PSDU
+     * @return an MPDU that has been dropped, if any, to be notified to the remote station manager
+     *         through the appropriate function
+     */
+    Ptr<WifiMpdu> DropMpduIfRetryLimitReached(Ptr<WifiPsdu> psdu);
 
     /**
      * Called when the Ack timeout expires.
      *
-     * \param mpdu the MPDU that solicited a Normal Ack response
-     * \param txVector the TXVECTOR used to transmit the frame soliciting the Normal Ack
+     * @param mpdu the MPDU that solicited a Normal Ack response
+     * @param txVector the TXVECTOR used to transmit the frame soliciting the Normal Ack
      */
     virtual void NormalAckTimeout(Ptr<WifiMpdu> mpdu, const WifiTxVector& txVector);
 
     /**
      * Called when the CTS timeout expires.
      *
-     * \param rts the RTS that solicited a CTS response
-     * \param txVector the TXVECTOR used to transmit the RTS frame
+     * @param rts the RTS that solicited a CTS response
+     * @param txVector the TXVECTOR used to transmit the RTS frame
      */
     virtual void CtsTimeout(Ptr<WifiMpdu> rts, const WifiTxVector& txVector);
     /**
      * Take required actions when the CTS timer fired after sending an RTS to
      * protect the given PSDU expires.
      *
-     * \param psdu the PSDU protected by the failed RTS
+     * @param psdu the PSDU protected by the failed RTS
      */
     void DoCtsTimeout(Ptr<WifiPsdu> psdu);
 
     /**
+     * @return whether CW shall be updated on CTS timeout
+     */
+    virtual bool GetUpdateCwOnCtsTimeout() const;
+
+    /**
      * Reset this frame exchange manager.
      */
     virtual void Reset();
 
     /**
-     * \param txVector the TXVECTOR decoded from PHY header.
-     * \param psduDuration the duration of the PSDU that is about to be received.
+     * @param txVector the TXVECTOR decoded from PHY header.
+     * @param psduDuration the duration of the PSDU that is about to be received.
      *
      * This method is typically invoked by the lower PHY layer to notify
      * the MAC layer that the reception of a PSDU is starting.
@@ -689,14 +720,21 @@
     /**
      * Store information about the MAC header of the MPDU being received.
      *
-     * \param macHdr the MAC header of the MPDU being received
-     * \param txVector the TXVECTOR used to transmit the PSDU
-     * \param psduDuration the remaining duration of the PSDU
+     * @param macHdr the MAC header of the MPDU being received
+     * @param txVector the TXVECTOR used to transmit the PSDU
+     * @param psduDuration the remaining duration of the PSDU
      */
     virtual void ReceivedMacHdr(const WifiMacHeader& macHdr,
                                 const WifiTxVector& txVector,
                                 Time psduDuration);
 
+    /**
+     * Notify the last (re)transmission of a groupcast MPDU using the GCR-UR service.
+     *
+     * @param mpdu the groupcast MPDU
+     */
+    virtual void NotifyLastGcrUrTx(Ptr<const WifiMpdu> mpdu);
+
   private:
     /**
      * Send the current MPDU, which can be acknowledged by a Normal Ack.
